
`timescale 1 ps/ 1 ps // 1 picosecond steps, 1 picosecond precision.

module CV_PLL_test #(
parameter string     FPGA_VENDOR             = "Altera",
parameter string     FPGA_FAMILY             = "Cyclone V"
)
(
RST_IN,    // Reset input
CLK_IN,

ck0,ck1,
ck3,ck4,

in_ck2,
ck2_out0,

PLL_LOCKED,
phase_step,
phase_updn,
phase_sclk,
phase_done
);

input        RST_IN,CLK_IN;
output logic ck0,ck1,ck3,ck4,PLL_LOCKED;

input        [7:0] in_ck2;
output logic [7:0] ck2_out0;

input        phase_step,phase_updn,phase_sclk;
output logic phase_done;

logic DDR3_CLK,DDR3_CLK_WDQ,DDR3_CLK_RDQ,DDR3_CLK_50,DDR3_CLK_25;
logic [7:0] ck2_lat1,ck2_lat2,ck2_lat3,ck2_lat4;
// *********************************************************************************************
// This module generates the master reference clocks for the entire memory system.
// *********************************************************************************************
cvpll  DDR3_PLL (   .rst        (RST_IN),             .refclk        (CLK_IN),             .outclk_0    (DDR3_CLK),
                    .outclk_1   (DDR3_CLK_WDQ),       .outclk_2      (DDR3_CLK_RDQ),       .locked      (PLL_LOCKED),
                    .outclk_3   (DDR3_CLK_50),        .outclk_4      (DDR3_CLK_25),

                    .phase_en       ( phase_step ),   .updn            ( phase_updn ),     .cntsel (5'd4),
                    .scanclk        ( phase_sclk ),   .phase_done      ( phase_done ) );

always @(posedge DDR3_CLK     ) ck0     <= !ck0 ;
always @(posedge DDR3_CLK_WDQ ) ck1     <= !ck1 ;
always @(posedge DDR3_CLK_50  ) ck3     <= !ck3 ;
always @(posedge DDR3_CLK_25  ) ck4     <= !ck4 ;

// Test transfer an input on clock DDR3_CLK_RDQ going out to DDR3_CLK
always @(posedge DDR3_CLK_RDQ ) ck2_lat1 <=  in_ck2 ;
always @(posedge DDR3_CLK_RDQ ) ck2_lat2 <=  ck2_lat1 ;

always @(posedge DDR3_CLK     ) ck2_lat3 <=  ck2_lat2 ;
always @(posedge DDR3_CLK     ) ck2_lat4 <=  ck2_lat3 ;

always @(posedge DDR3_CLK     ) ck2_out0 <=  ck2_lat4 ;

endmodule
